---
title: Mixed content
slug: Web/Security/Mixed_content
tags:
  - HTTP
  - HTTPS
  - Security
  - Web
  - console
---
<p>When a user visits a page served over {{Glossary("HTTPS")}}, their connection with the web server is encrypted with {{Glossary("TLS")}} and is therefore safeguarded from most sniffers and man-in-the-middle attacks. <span class="seoSummary">An HTTPS page that includes content fetched using cleartext HTTP is called a <strong>mixed content</strong> page. Pages like this are only partially encrypted, leaving the unencrypted content accessible to sniffers and man-in-the-middle attackers.</span> That leaves the pages unsafe.</p>

<h2 id="Types_of_mixed_content">Types of mixed content</h2>

<p>There are two categories for mixed content: <strong>mixed passive/display content</strong> and <strong>mixed active content</strong>. The difference lies in the threat level of the worst case scenario if content is rewritten as part of a man-in-the-middle attack. In the case of passive content, the threat is lower (the page may contain misleading content, or the user's cookies may be stolen). In the case of active content, the threat can lead to phishing, sensitive data disclosure, redirection to malicious sites, etc.</p>

<h3 id="Mixed_passivedisplay_content">Mixed passive/display content</h3>

<p>Mixed passive/display content is content served over HTTP that is included in an HTTPS webpage, but that cannot alter other portions of the webpage. For example, an attacker could replace an image served over HTTP with an inappropriate image or message to the user. The attacker could also infer information about the user's activities by watching which images are served to the user; often images are only served on a specific page within a website. If the attacker observes HTTP requests to certain images, they could determine which webpage the user is visiting.</p>

<div class="notecard note"></div>

<h4 id="Passive_content_list">Passive content list</h4>

<p>This section lists all types of HTTP requests which are considered passive content:</p>

<ul>
 <li>{{HTMLElement("img")}} (<code>src</code> attribute)</li>
 <li>{{HTMLElement("audio")}} (<code>src</code> attribute)</li>
 <li>{{HTMLElement("video")}} (<code>src</code> attribute)</li>
 <li>{{HTMLElement("object")}} subresources (when an <code>&lt;object&gt;</code> performs HTTP requests)</li>
</ul>

<h3 id="Mixed_active_content">Mixed active content</h3>

<p><strong>Mixed active content</strong> is content that has access to all or parts of the Document Object Model of the HTTPS page. This type of mixed content can alter the behavior of the HTTPS page and potentially steal sensitive data from the user. Hence, in addition to the risks described for mixed display content above, mixed active content is vulnerable to a few other attack vectors.</p>

<p>In the mixed active content case, a man-in-the-middle attacker can intercept the request for the HTTP content. The attacker can also rewrite the response to include malicious JavaScript code. Malicious active content can steal the user's credentials, acquire sensitive data about the user, or attempt to install malware on the user's system (by leveraging vulnerabilities in the browser or its plugins, for example).</p>

<p>The risk involved with mixed content does depend on the type of website the user is visiting and how sensitive the data exposed to that site may be. The webpage may have public data visible to the world or private data visible only when authenticated. If the webpage is public and has no sensitive data about the user, using mixed active content still provides the attacker with the opportunity to redirect the user to other HTTP pages and steal HTTP cookies from those sites.</p>

<h4 id="Active_content_examples">Active content examples</h4>

<p>This section lists some types of HTTP requests which are considered active content:</p>

<ul>
 <li>{{HTMLElement("script")}} (<code>src</code> attribute)</li>
 <li>{{HTMLElement("link")}} (<code>href</code> attribute) (this includes CSS stylesheets)</li>
 <li>{{HTMLElement("iframe")}} (<code>src</code> attribute)</li>
 <li>{{domxref("XMLHttpRequest")}} requests</li>
 <li>{{domxref("GlobalFetch.fetch","fetch()")}} requests</li>
 <li>All cases in CSS where a {{cssxref("url")}} value is used ({{cssxref("@font-face")}}, {{cssxref("cursor")}}, {{cssxref("background-image")}}, and so forth).</li>
 <li>{{HTMLElement("object")}} (<code>data</code> attribute)</li>
 <li>{{domxref("Navigator.sendBeacon")}} (<code>url</code> attribute)</li>
</ul>

<p>Other resource types like web fonts and workers may be considered active mixed content, as they are in Chrome.</p>

<h2 id="Loading_mixed-content_resources">Loading mixed-content resources</h2>

<p>Most browsers prevent <em>mixed active content</em> from loading, and some also block <em>mixed display content</em>.</p>

<h3 id="Loading_locally_delivered_mixed-resources">Loading locally delivered mixed-resources</h3>

<p>Browsers <em>may</em> allow locally-delivered mixed resources to be loaded. This includes <code>file:</code> URLs and content accessed from loopback addresses (e.g. <code>http://127.0.0.1/</code>).</p>

<ul>
 <li>Firefox 55 and later allow loading of mixed content on the loopback address <code>http://127.0.0.1/</code> (see {{bug(903966)}}),</li>
 <li>Firefox 84 and later allow loading of mixed content on <code>http://localhost/</code> and <code>http://*.localhost/</code> URLs, as these are now mapped to loopback addresses (see {{bug(1220810)}}).</li>
 <li>Chrome also allows mixed content on <code>http://127.0.0.1/</code> and <code>http://localhost/</code>.</li>
 <li>Safari does not allow any mixed content.</li>
</ul>

<h3 id="Upgrading_mixed-display_resources">Upgrading mixed-display resources</h3>

<p>Browsers may support automatic upgrade of requests for display/media content from HTTP to HTTPS on secure pages (this prevents mixed-content conditions in which some content is loaded securely while other content is insecure).</p>

<div class="notecard note">
<p>Firefox 60 and later support this functionality as an experimental feature. It can be enabled using the preference <code>security.mixed_content.upgrade_display_content</code>).</p>

<ul>
 <li>If the upgrade fails (because the media's host doesn't support HTTPS), the media is not loaded.</li>
 <li>Console warnings indicate when content has been successfully upgraded.</li>
 <li>For more information see <a href="/en-US/docs/Mozilla/Firefox/Experimental_features#Upgrading_mixed_display_content">Experimental features in Firefox &gt; Upgrading mixed display content</a>.</li>
</ul>
</div>

<h2 id="Warnings_in_Firefox_Web_Console"><span>Warnings in Firefox Web Console</span></h2>

<p>The Firefox Web Console displays a mixed content warning message in the Net pane when a page on your website has this issue. The mixed content resource that was loaded via HTTP will show up in red, along with the text "mixed content", which links to this page.</p>

<p><a class="internal" href="/files/12545/Mixed_content_-_Net_pane.png"><img alt="Screen shot of the web console displaying a mixed content warning." src="https://mdn.mozillademos.org/files/12545/Mixed_content_-_Net_pane.png" style="border-style: solid; border-width: 1px; height: 286px; width: 720px;"></a></p>

<p>As well as finding these warnings in the Web Console, you could use <a href="/en-US/docs/Web/HTTP/CSP">Content Security Policy (CSP)</a> to report issues. You could also use an online crawler like <a href="http://www.jitbit.com/sslcheck/" rel="noopener">SSL-check</a> or <a href="https://www.missingpadlock.com/" rel="noopener">Missing Padlock</a> that will check your website recursively and find links to insecure content.</p>

<p>Starting in Firefox 23, mixed active content is blocked by default (and mixed display content can be blocked by setting a preference). To make it easier for web developers to find mixed content errors, all blocked mixed content requests are logged to the Security pane of the Web Console, as seen below:</p>

<p><a href="/files/5261/blocked-mixed-content-errors.png"><img alt="A screenshot of blocked mixed content errors in the Security Pane of the Web Console" src="https://mdn.mozillademos.org/files/12543/mixed_content_webconsole.png" style="border-style: solid; border-width: 1px; height: 285px; width: 720px;"></a></p>

<p>To fix this type of error, all requests to HTTP content should be removed and replaced with content served over HTTPS. Some common examples of mixed content include JavaScript files, stylesheets, images, videos, and other media.</p>

<div class="notecard note">
<p><strong>Note</strong>: The console will display a message indicating if mixed-display content is being successfully <a href="#Upgrading_mixed-display_resources">upgraded from HTTP to HTTPS</a>  (instead of a warning about "Loading mixed (insecure) display content").</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://w3c.github.io/webappsec/specs/mixedcontent/">Mixed Content - W3C Editor's Draft</a></li>
 <li><a href="/en-US/docs/Security/Mixed_content/How_to_fix_website_with_mixed_content">How to fix a website with blocked mixed content</a></li>
</ul>

<p>{{QuickLinksWithSubpages("/en-US/docs/Web/Security")}}</p>
